blob: a4fba8355db278c52a88a218e7bbc3daea6488cb [file] [log] [blame]
Miguel Osorio03f2e232019-09-17 19:44:37 -07001#!/bin/bash
2# Copyright lowRISC contributors.
3# Licensed under the Apache License, Version 2.0, see LICENSE for details.
4# SPDX-License-Identifier: Apache-2.0
5
6set -o errexit
7set -o pipefail
8set -o nounset
9
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060010# meson_init.sh configures OpenTitan's Meson build system. Rather than calling
11# Meson directly, this script should be used instead, since it handles things
12# that Meson does not out of the box, such as:
13# - The RISC-V toolchain.
14# - Idempotence.
15# - Building for multiple device platforms.
16#
17# This script's semantics for creating build directories are as follows:
18# - By default, this script will create any missing build directories and
19# configure them. It is idempotent: if there is no work to be done, nothing
20# will change and this script will exit successfully.
21# - Passing -r will reconfigure existing build directories. This should be used
22# when editing meson.build files.
23# - Passing -f will erase existing build directories. This should be used when
24# existing configuration is completely broken, or a clean build is desired
25# (neither of these should be necessary).
26# - Passing -A will explicitly disable idempotence, and cause the script to exit
27# if a build directory already exists. This should be used only in CI, where
28# such error-checking is desireable.
29#
30# Note that only the first option above is actually guaranteed to be idempotent.
31
Miguel Young de la Sota63793572019-11-13 14:18:51 -060032. util/build_consts.sh
33
34echo "Detected \$REPO_TOP at $REPO_TOP."
35echo "Object directory set at $OBJ_DIR."
36echo "Binary directory set at $BIN_DIR."
Miguel Young de la Sotab2ef4832019-11-22 12:55:46 -060037echo "OpenTitan version: $OT_VERSION"
Miguel Young de la Sota63793572019-11-13 14:18:51 -060038echo
Miguel Osorio03f2e232019-09-17 19:44:37 -070039
40function usage() {
41 cat << USAGE
42Configure Meson build targets.
43
Sam Elliottc09da262020-06-03 11:10:36 +010044Usage: $0 [-r|-f|-A|-K|-T|-t]
Miguel Osorio03f2e232019-09-17 19:44:37 -070045
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060046 -f: Force a reconfiguration by removing existing build dirs.
47 -r: Reconfigure build dirs, if they exist.
48 -A: Assert that no build dirs exist when running this command.
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050049 -K: Keep include search paths as generated by Meson.
Sam Elliottc09da262020-06-03 11:10:36 +010050 -t FILE: Configure Meson with toolchain configuration FILE
Jon Flatleya863a282020-03-03 10:49:39 -050051 -T PATH: Build tock from PATH rather than the remote repository.
Miguel Osorio03f2e232019-09-17 19:44:37 -070052
53USAGE
54}
55
Sam Elliottc09da262020-06-03 11:10:36 +010056readonly DEFAULT_RISCV_TOOLS=/tools/riscv
57TOOLCHAIN_PATH="${TOOLCHAIN_PATH:-$DEFAULT_RISCV_TOOLS}"
58
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060059FLAGS_assert=false
Miguel Osorio03f2e232019-09-17 19:44:37 -070060FLAGS_force=false
61FLAGS_reconfigure=""
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050062FLAGS_keep_includes=false
Sam Elliottc09da262020-06-03 11:10:36 +010063FLAGS_specified_toolchain_file=false
Luís Marques5849cd12020-06-26 10:33:55 +010064ARG_toolchain_file="${TOOLCHAIN_PATH}/meson-riscv32-unknown-elf-clang.txt"
Jon Flatleya863a282020-03-03 10:49:39 -050065ARG_tock_dir=""
Sam Elliottc09da262020-06-03 11:10:36 +010066while getopts 'r?:f?:K?:A?:T:t:' flag; do
Miguel Osorio03f2e232019-09-17 19:44:37 -070067 case "${flag}" in
68 f) FLAGS_force=true;;
69 r) FLAGS_reconfigure="--reconfigure";;
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060070 A) FLAGS_assert=true;;
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050071 K) FLAGS_keep_includes=true;;
Sam Elliottc09da262020-06-03 11:10:36 +010072 t) FLAGS_specified_toolchain_file=true
73 ARG_toolchain_file="${OPTARG}";;
Jon Flatleya863a282020-03-03 10:49:39 -050074 T) ARG_tock_dir="${OPTARG}";;
Miguel Osorio03f2e232019-09-17 19:44:37 -070075 ?) usage && exit 1;;
Jon Flatleya863a282020-03-03 10:49:39 -050076 :) usage
77 error "${OPTARG} requires a path argument"
78 ;;
Miguel Osorio03f2e232019-09-17 19:44:37 -070079 *) usage
80 error "Unexpected option ${flag}"
81 ;;
82 esac
83done
84
Miguel Osorio03f2e232019-09-17 19:44:37 -070085if [[ ! -n "$(command -v meson)" ]]; then
86 echo "Unable to find meson. Please install meson before running this command." >&2
87 exit 1
88fi
89
90if [[ ! -n "$(command -v ninja)" ]]; then
91 echo "Unable to find ninja. Please install ninja before running this command." >&2
92 exit 1
93fi
94
95if [[ "${FLAGS_force}" == true ]]; then
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060096 rm -rf "$OBJ_DIR"
97 rm -rf "$BIN_DIR"
Miguel Osorio03f2e232019-09-17 19:44:37 -070098fi
99
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600100if [[ "${FLAGS_assert}" == true ]]; then
101 if [[ -e "$OBJ_DIR" ]]; then
102 echo "Object directory at $OBJ_DIR already exists. Aborting." >&2
103 exit 1
104 fi
105 if [[ -e "$BIN_DIR" ]]; then
106 echo "Binary directory at $BIN_DIR already exists. Aborting." >&2
107 exit 1
108 fi
Miguel Osorio03f2e232019-09-17 19:44:37 -0700109fi
110
Jon Flatleya863a282020-03-03 10:49:39 -0500111TOCK_LOCAL=false
112if [[ ! -z "${ARG_tock_dir}" ]]; then
113 TOCK_LOCAL=true
114
115 if [[ ! -d "${ARG_tock_dir}" ]]; then
116 echo "Referenced Tock directory ${ARG_tock_dir} doesn't exist. Aborting." >&2
117 exit 1
118 fi
119
120 if [[ ! -f "${TOCK_SYMLINK}" || -L "${TOCK_SYMLINK}" ]]; then
121 echo "Creating symlink to Tock project at ${ARG_tock_dir}."
122 ln -sf "${ARG_tock_dir}" "${TOCK_SYMLINK}"
123 elif [[ -d "${TOCK_SYMLINK}" ]]; then
124 echo "Tock directory $TOCK_SYMLINK exists in place. Leaving as is."
125 else
126 echo "Placing Tock at ${TOCK_SYMLINK} would clobber something. Aborting." >&2
127 exit 1
128 fi
129fi
130
Sam Elliottc09da262020-06-03 11:10:36 +0100131if [[ -f "${ARG_toolchain_file}" ]]; then
132 echo "Using meson toolchain file at $ARG_toolchain_file." >&2
133else
134 if [[ "${FLAGS_specified_toolchain_file}" == true ]]; then
135 echo "Unable to find meson toolchain file at $ARG_toolchain_file. Aborting." >&2
136 exit 1
137 else
138 cross_file=$(mktemp /tmp/toolchain.XXXXXX.txt)
139 cp toolchain.txt "$cross_file"
140 perl -pi -e "s#$DEFAULT_RISCV_TOOLS#$TOOLCHAIN_PATH#g" "$cross_file"
141 echo "Set up toolchain file at $cross_file." >&2
142 ARG_toolchain_file="${cross_file}"
143 fi
144fi
Miguel Young de la Sotad258b332019-10-29 14:05:23 -0500145
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500146reconf="${FLAGS_reconfigure}"
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600147
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500148if [[ ! -d "$OBJ_DIR" ]]; then
149 echo "Output directory does not exist at $OBJ_DIR; creating." >&2
150 mkdir -p "$OBJ_DIR"
151 reconf=""
152elif [[ -z "$reconf" ]]; then
153 echo "Output directory already exists at $OBJ_DIR; skipping." >&2
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500154fi
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600155
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500156mkdir -p "$DEV_BIN_DIR"
157set -x
158meson $reconf \
159 -Dot_version="$OT_VERSION" \
160 -Ddev_bin_dir="$DEV_BIN_DIR" \
161 -Dhost_bin_dir="$HOST_BIN_DIR" \
Jon Flatleya863a282020-03-03 10:49:39 -0500162 -Dtock_local="$TOCK_LOCAL" \
Sam Elliott371c79f2020-06-23 20:06:19 +0100163 -Dkeep_includes="$FLAGS_keep_includes" \
Sam Elliottc09da262020-06-03 11:10:36 +0100164 --cross-file="$ARG_toolchain_file" \
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500165 "$OBJ_DIR"